UIPackage
Menu

Framework

Change language

Boilerplate repo

Pie Chart

pie-chartui

React mirror of @uipkge/pie-chart — see the Vue registry item for the canonical description.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/pie-chart.json
Named registry:npx shadcn@latest add @uipkge-react/pie-chartInstalls to:components/ui/charts/pie-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
dataRecord<string, any>[]required
nameFieldstringoptional
valueFieldstringoptional
heightnumber | stringoptional
donutbooleanoptional
optionanyoptional
classNamestringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

ChartTheme
interface ChartTheme {
  colors: string[]
  textColor: string
  axisColor: string
  splitLineColor: string
  tooltipBg: string
  tooltipBorder: string
  tooltipText: string
  bgColor: string
  /** The app's accent, for the one highlighted element on a chart or map —
   *  a selected route, a focused bar. Category series keep using `colors`. */
  accentColor: string
  /** Out-of-bounds / failure colour for charts that encode good vs bad
   *  rather than a category — control limits, error series. CSS-level marks
   *  can use `var(--destructive)` directly; this exists because ECharts needs
   *  a resolved colour string on the canvas. */
  dangerColor: string
}

npm dependencies

Used by

Files installed (4)

  • components/ui/charts/pie-chart/PieChart.tsx2.2 kB
    'use client'
    
    import * as React from 'react'
    import ReactECharts from 'echarts-for-react/esm/core'
    import { ChartFrame, EChart } from '../shared'
    import { useChartTheme } from '../useChartTheme'
    
    // PieChart
    // ─────────────────────────────────────────────────────────────────────────
    
    export interface PieChartProps {
      data: Record<string, any>[]
      nameField?: string
      valueField?: string
      height?: number | string
      donut?: boolean
      option?: any
      className?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    export const PieChart = React.forwardRef<HTMLDivElement, PieChartProps>(
      (
        { data, nameField = 'name', valueField = 'value', height = 300, donut = false, option, className, ariaLabel },
        ref,
      ) => {
        const theme = useChartTheme()
    
        const mergedOption = React.useMemo(() => {
          const chartData = data.map((d) => ({
            name: d[nameField],
            value: d[valueField],
          }))
    
          const series = [
            {
              type: 'pie',
              radius: donut ? ['45%', '70%'] : '65%',
              center: ['50%', '45%'],
              itemStyle: { borderWidth: 0 },
              label: { show: false },
              data: chartData,
            },
          ]
    
          const userOption: any = option ?? {}
          const { series: userSeries, ...userRest } = userOption
          const mergedSeries = Array.isArray(userSeries)
            ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) }))
            : series
    
          return {
            color: theme.colors,
            tooltip: {
              trigger: 'item',
              backgroundColor: theme.tooltipBg,
              borderColor: theme.tooltipBorder,
              textStyle: { color: theme.tooltipText, fontSize: 12 },
              formatter: '{b}: {c} ({d}%)',
            },
            legend: {
              bottom: 0,
              icon: 'circle',
              itemWidth: 8,
              itemHeight: 8,
              textStyle: { fontSize: 11 },
            },
            series: mergedSeries,
            ...userRest,
          }
        }, [data, nameField, valueField, donut, option, theme])
    
        return (
          <ChartFrame ref={ref} height={height} className={className} ariaLabel={ariaLabel}>
            <EChart option={mergedOption} />
          </ChartFrame>
        )
      },
    )
    PieChart.displayName = 'PieChart'
    
  • components/ui/charts/pie-chart/index.ts0.1 kB
  • components/ui/charts/useChartTheme.ts8.7 kB
  • components/ui/charts/shared.tsx3.7 kB

Raw manifest:https://uipkge.dev/r/react/pie-chart.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Pie Chart

pie-chartui

Pie chart wrapper around Apache ECharts. Full pie, donut, rose (Nightingale), and labeled variants. Theme-aware via registry tokens.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/pie-chart.json
Named registry:npx shadcn-vue@latest add @uipkge/pie-chartInstalls to:app/components/ui/charts/pie-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
dataRecord<string, any>[]required
nameFieldstring'name'optional
valueFieldstring'value'optional
heightnumber | string300optional
donutbooleanfalseoptional
optionanyoptional
classstringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

npm dependencies

Used by

Files installed (3)

  • app/components/ui/charts/pie-chart/PieChart.vue2.4 kB
    <script setup lang="ts">
    import { computed } from 'vue'
    import { use } from 'echarts/core'
    import { CanvasRenderer } from 'echarts/renderers'
    import { PieChart as EChartsPieChart } from 'echarts/charts'
    import { TooltipComponent, LegendComponent } from 'echarts/components'
    import VChart from 'vue-echarts'
    import { cn } from '@/lib/utils'
    import { chartColors, chartTooltipBg, chartTooltipBorder, chartTooltipText } from '../useChartTheme'
    
    use([CanvasRenderer, EChartsPieChart, TooltipComponent, LegendComponent])
    
    interface Props {
      data: Record<string, any>[]
      nameField?: string
      valueField?: string
      height?: number | string
      donut?: boolean
      option?: any
      class?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    const props = withDefaults(defineProps<Props>(), {
      nameField: 'name',
      valueField: 'value',
      height: 300,
      donut: false,
    })
    
    const mergedOption = computed(() => {
      const chartData = props.data.map((d) => ({
        name: d[props.nameField!],
        value: d[props.valueField!],
      }))
    
      const series = [
        {
          type: 'pie',
          radius: props.donut ? ['45%', '70%'] : '65%',
          center: ['50%', '45%'],
          itemStyle: { borderWidth: 0 },
          label: { show: false },
          data: chartData,
        },
      ]
    
      // Per-index series merge — partial overrides keep computed `type`/`data`.
      const userOption: any = props.option ?? {}
      const { series: userSeries, ...userRest } = userOption
      const mergedSeries = Array.isArray(userSeries) ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) })) : series
    
      return {
        color: chartColors.value,
        tooltip: {
          trigger: 'item',
          backgroundColor: chartTooltipBg.value,
          borderColor: chartTooltipBorder.value,
          textStyle: { color: chartTooltipText.value, fontSize: 12 },
          formatter: '{b}: {c} ({d}%)',
        },
        legend: {
          bottom: 0,
          icon: 'circle',
          itemWidth: 8,
          itemHeight: 8,
          textStyle: { fontSize: 11 },
        },
        series: mergedSeries,
        ...userRest,
      }
    })
    </script>
    
    <template>
      <div
        role="img"
        tabindex="0"
        :aria-label="ariaLabel || 'Chart'"
        :style="{ height: /^\d+$/.test(String(height)) ? `${height}px` : String(height) }"
        :class="cn('focus-visible:ring-ring w-full focus-visible:ring-2 focus-visible:outline-none', props.class)"
      >
        <VChart :option="mergedOption" :autoresize="true" class="size-full" />
      </div>
    </template>
    
  • app/components/ui/charts/pie-chart/index.ts0.1 kB
  • app/components/ui/charts/useChartTheme.ts8.2 kB

Raw manifest:https://uipkge.dev/r/vue/pie-chart.json